export const vehicleTypesList = [
	"megaverse:aircraft",
	"megaverse:automobile",
	"megaverse:motorbike",
	"megaverse:rotorcraft"
];
export const vehicleTypes = {
	"megaverse:motorbike": {
		properties: {
			engine: "megaverse:vehicle_engine_state",
			engineState: [ "unpowered", "powered" ],
			fuelAmount: "megaverse:vehicle_fuel_amount",
			hasRider: "megaverse:vehicle_has_rider",
			movementVelocity: "megaverse:vehicle_movement_velocity"
		},
		maxDefaultVelocity: 0.45,
		maxVelocityInWater: 0.10,
		minDefaultVelocity: -0.05,
		vehicleInputs: {
			threshold: 0.5,
			noAcceleration: 0.0,
			forwardAcceleration: 1.0,
			forwardDiagonalAcceleration: 0.5,
			backwardAcceleration: -1.0,
			backwardDiagonalAcceleration: -0.5,
			movementOnDefault: 1.00,
			movementOnGround: 1.00,
			movementOnWater: 0.125,//0.25 as similar to OnGround
			movementOnAir: 0.125,//0.5 if you want Harry Potter
			inputDirections: {
				"0,1": "forwardAcceleration",
				"1,1": "forwardDiagonalAcceleration",
				"-1,1": "forwardDiagonalAcceleration",
				"0,-1": "backwardAcceleration",
				"1,-1": "backwardDiagonalAcceleration",
				"-1,-1": "backwardDiagonalAcceleration"
			},
			inputRotations: {//currently unused.
				forwardDegrees: 12.5,
				backwardDegrees: 10.0
			}
		},
		velocityProperties: {
			forwardAcceleration: [
				[0.0, 0.10, 0.0015],
				[0.10, 0.24, 0.0030],
				[0.24, 0.30, 0.00015],
				[0.30, 0.44, 0.00030],
				[0.44, Infinity, 0.0015]
			],
			backwardAcceleration: [
				[0.0, 0.01, 0.000125],
				[0.01, 0.02, 0.00025],
				[0.02, 0.03, 0.0005],
				[0.03, 0.04, 0.001],
				[0.04, Infinity, 0.002]
			],
			deceleration: [
				[0.30, Infinity, 0.001],
				[0.24, 0.30, 0.0005],
				[0.10, 0.24, 0.001],
				[0.0, 0.10, 0.002]
			],
			defaultDecay: 0.002,
			driving: {
				velocity: 0.24,
				decay: 0.001
			},
			speeding: {
				velocity: 0.30,
				decay: 0.0005
			}
		}
	}
};