import { world, system } from "@minecraft/server";
import * as defaultWorldArrays from "../arrays/default_world_arrays.js"
import * as dragonUtilities from "../utilities/dragon_utilities.js"

system.runInterval(() => {
	for (const dim of defaultWorldArrays.addonDimensions) {
		const entities = world.getDimension(dim).getEntities(dragonUtilities.dragonTypes);
		for (const dragon of entities) {
			dragonUtilities.dragonsMainComponents(dragon);
		}
	}
}, 0);

function getPlayerControlMovement(player) {
    var movement = player.inputInfo.getMovementVector();
    // Threshold to classify directions
    var threshold = 0.5;
    // Determine the normalized direction
    var normalizedX =
        Math.abs(movement.x) >= threshold ? (movement.x > 0 ? 1 : -1) : 0;
    var normalizedY =
        Math.abs(movement.y) >= threshold ? (movement.y > 0 ? 1 : -1) : 0;
    // Define direction based on normalized x and y
    if (normalizedX === 0 && normalizedY === 1) return "Forward";
    if (normalizedX === 0 && normalizedY === -1) return "Backward";
    if (normalizedX === 1 && normalizedY === 0) return "Left";
    if (normalizedX === -1 && normalizedY === 0) return "Right";
    if (normalizedX === 1 && normalizedY === 1) return "Forward-left";
    if (normalizedX === -1 && normalizedY === 1) return "Forward-right";
    if (normalizedX === 1 && normalizedY === -1) return "Backward-left";
    if (normalizedX === -1 && normalizedY === -1) return "Backward-right";
    if (normalizedX === 0 && normalizedY === 0) return "None";
    // Handle unexpected cases
    return "Unknown";
}
// Example to display movement control
/*system.runInterval(function () {
    world.getAllPlayers().forEach(function (player) {
        var status = getPlayerControlMovement(player);
        player.onScreenDisplay.setActionBar("Movement: ".concat(status));
    });
});*/