import { world, system, BlockPermutation, ItemStack } from "@minecraft/server";
import * as blockArrays from "../arrays/block_arrays.js"
import * as itemUtilities from "../utilities/item_utilities.js"

world.beforeEvents.playerInteractWithEntity.subscribe((event) => {
	const {cancel,itemStack,player,target} = event;
	if (target.typeId!="megaverse:dracon") return;
	const isBaby = target.getComponent("is_baby");
	const isTamed = target.getComponent("is_tamed");
    if (!isBaby&&isTamed&&itemStack.typeId=="minecraft:ghast_tear") {
        system.run(() => {
        	itemUtilities.itemDecrementStack(itemStack,player);
            target.dimension.spawnItem(new ItemStack(`${target.typeId}_spawn_egg`,1),target.location);
            target.remove();
        });
    }
    else if (itemStack.typeId=="minecraft:ghast_tear") return player.sendMessage(">:(");
});

world.afterEvents.dataDrivenEntityTrigger.subscribe(({entity,eventId}) => {
	if (entity.typeId=="megaverse:silkworm"&&eventId=="minecraft:entity_transformed") {
		const blockLocate = entity.dimension.getBlock(entity.location);
		const blockBelow = entity.dimension.getBlock({x:entity.location.x,y:entity.location.y-1,z:entity.location.z});
		if ((blockLocate.isAir||(blockLocate.typeId=="minecraft:flowing_water"||blockLocate.typeId=="minecraft:water"))&&!blockBelow.isAir&&!blockArrays.silkwormCocoonDenyBlocks.includes(blockBelow.typeId)) {
			blockLocate.dimension.spawnParticle("megaverse:frost",blockLocate.center());
			blockLocate.setPermutation(BlockPermutation.resolve("megaverse:silkworm_cocoon",{"minecraft:block_face":"up"}));
			entity.triggerEvent("minecraft:despawned");
		}
	}
});